version: '3.5'
services:
 zabbix-server:
  image: zabbix/zabbix-server-pgsql:alpine-6.0-latest
    #  ports:
    #   - "10051:10051"
  volumes:
   - /etc/localtime:/etc/localtime:ro
   - /etc/timezone:/etc/timezone:ro 
#   - ./zbx_env/usr/lib/zabbix/alertscripts:/usr/lib/zabbix/alertscripts:ro
#   - ./zbx_env/usr/lib/zabbix/externalscripts:/usr/lib/zabbix/externalscripts:ro
#   - ./zbx_env/var/lib/zabbix/dbscripts:/var/lib/zabbix/dbscripts:ro
#   - ./zbx_env/var/lib/zabbix/export:/var/lib/zabbix/export:rw
#   - ./zbx_env/var/lib/zabbix/modules:/var/lib/zabbix/modules:ro
#   - ./zbx_env/var/lib/zabbix/enc:/var/lib/zabbix/enc:ro
#   - ./zbx_env/var/lib/zabbix/ssh_keys:/var/lib/zabbix/ssh_keys:ro
#   - ./zbx_env/var/lib/zabbix/mibs:/var/lib/zabbix/mibs:ro
#   - ./zbx_env/var/lib/zabbix/snmptraps:/var/lib/zabbix/snmptraps:ro
#   - ./env_vars/.ZBX_DB_CA_FILE:/run/secrets/root-ca.pem:ro
#   - ./env_vars/.ZBX_DB_CERT_FILE:/run/secrets/client-cert.pem:ro
#   - ./env_vars/.ZBX_DB_KEY_FILE:/run/secrets/client-key.pem:ro
  ulimits:
   nproc: 65535
   nofile:
    soft: 20000
    hard: 40000
  deploy:
   resources:
    limits:
      cpus: '0.5'
      memory: 500M
  env_file:
   - ./env_vars/.env_db_pgsql
   - ./env_vars/.env_srv
  secrets:
   - POSTGRES_USER
   - POSTGRES_PASSWORD
  restart: always
  depends_on:
   - postgres-server
  networks:
   zbx_net_backend:
     aliases:
      - zabbix-server
      - zabbix-server-pgsql
      - zabbix-server-alpine-pgsql
      - zabbix-server-pgsql-alpine
   zbx_net_frontend:
#  devices:
#   - "/dev/ttyUSB0:/dev/ttyUSB0"
  stop_grace_period: 30s
  sysctls:
   - net.ipv4.ip_local_port_range=1024 65000
   - net.ipv4.conf.all.accept_redirects=0
   - net.ipv4.conf.all.secure_redirects=0
   - net.ipv4.conf.all.send_redirects=0

 zabbix-web-nginx-pgsql:
  image: zabbix/zabbix-web-nginx-pgsql:alpine-6.0-latest
    #ports:
    #- "80:8080"
    #- "443:8443"
  labels:
   - "traefik.enable=true"
   - "traefik.http.routers.zabbix.rule=Host(`zabbix.golem.oictinternal.cz`)"
   - "traefik.http.routers.zabbix.entrypoints=websecure"
   - "traefik.http.routers.zabbix.tls.certresolver=le"
   - "traefik.http.services.zabbix.loadbalancer.server.port=8080"
  volumes:
   - /etc/localtime:/etc/localtime:ro
   - /etc/timezone:/etc/timezone:ro
   - ./zbx_env/etc/ssl/nginx:/etc/ssl/nginx:ro
   - ./zbx_env/usr/share/zabbix/modules/:/usr/share/zabbix/modules/:ro
#   - ./env_vars/.ZBX_DB_CA_FILE:/run/secrets/root-ca.pem:ro
#   - ./env_vars/.ZBX_DB_CERT_FILE:/run/secrets/client-cert.pem:ro
#   - ./env_vars/.ZBX_DB_KEY_FILE:/run/secrets/client-key.pem:ro
  deploy:
   resources:
    limits:
      cpus: '0.70'
      memory: 512M
  env_file:
   - ./env_vars/.env_db_pgsql
   - ./env_vars/.env_web
  secrets:
   - POSTGRES_USER
   - POSTGRES_PASSWORD
  restart: always
  depends_on:
   - postgres-server
   - zabbix-server
  healthcheck:
   test: ["CMD", "curl", "-f", "http://localhost:8080/ping"]
   interval: 10s
   timeout: 5s
   retries: 3
   start_period: 30s
  networks:
   traefik:
   zbx_net_backend:
    aliases:
     - zabbix-web-nginx-pgsql
     - zabbix-web-nginx-alpine-pgsql
     - zabbix-web-nginx-pgsql-alpine
   zbx_net_frontend:
  stop_grace_period: 10s
  sysctls:
   - net.core.somaxconn=65535

 postgres-server:
  image: postgres:14.7-alpine
#  command: -c ssl=on -c ssl_cert_file=/run/secrets/server-cert.pem -c ssl_key_file=/run/secrets/server-key.pem -c ssl_ca_file=/run/secrets/root-ca.pem
  volumes:
   - /mnt/data/postgresql:/var/lib/postgresql/data:rw
#   - ./env_vars/.ZBX_DB_CA_FILE:/run/secrets/root-ca.pem:ro
#   - ./env_vars/.ZBX_DB_CERT_FILE:/run/secrets/server-cert.pem:ro
#   - ./env_vars/.ZBX_DB_KEY_FILE:/run/secrets/server-key.pem:ro
  env_file:
   - ./env_vars/.env_db_pgsql
  secrets:
   - POSTGRES_USER
   - POSTGRES_PASSWORD
  restart: always
  stop_grace_period: 1m
  networks:
   zbx_net_backend:
    aliases:
     - postgres-server
     - pgsql-server
     - pgsql-database
  deploy:
   resources:
    limits:
      cpus: '0.3'
      memory: 512M

# db_data_pgsql:
#  image: busybox
#  volumes:
#   - ./zbx_env/var/lib/postgresql/data:/var/lib/postgresql/data:rw

 zabbix-agent:
  image: zabbix/zabbix-agent:alpine-6.0-latest
  ports:
   - "10050:10050"
  volumes:
   - /etc/localtime:/etc/localtime:ro
   - /etc/timezone:/etc/timezone:ro
   - ./zbx_env/etc/zabbix/zabbix_agentd.d:/etc/zabbix/zabbix_agentd.d:ro
   - ./zbx_env/var/lib/zabbix/modules:/var/lib/zabbix/modules:ro
   - ./zbx_env/var/lib/zabbix/enc:/var/lib/zabbix/enc:ro
   - ./zbx_env/var/lib/zabbix/ssh_keys:/var/lib/zabbix/ssh_keys:ro
  deploy:
   resources:
    limits:
      cpus: '0.2'
      memory: 128M
    reservations:
      cpus: '0.1'
      memory: 64M
   mode: global
  env_file:
   - ./env_vars/.env_agent
  privileged: true
  pid: "host"
  networks:
   zbx_net_backend:
    aliases:
     - zabbix-agent
     - zabbix-agent-passive
     - zabbix-agent-alpine
   zbx_net_frontend:
  stop_grace_period: 5s
  labels:
   com.zabbix.description: "Zabbix agent"
   com.zabbix.company: "Zabbix LLC"
   com.zabbix.component: "zabbix-agentd"
   com.zabbix.os: "alpine"

networks:
  traefik:
    external: true
  zbx_net_frontend:
    driver: bridge
    driver_opts:
      com.docker.network.enable_ipv6: "false"
      com.docker.network.bridge.name: zbx-frontend
    ipam:
      driver: default
      config:
      - subnet: 172.16.238.0/24
  zbx_net_backend:
    driver: bridge
    driver_opts:
      com.docker.network.enable_ipv6: "false"
      com.docker.network.bridge.name: zbx-backend
    internal: true
    ipam:
      driver: default
      config:
      - subnet: 172.16.239.0/24

secrets:
  POSTGRES_USER:
    #file: ./secret_example/.POSTGRES_USER #use for test
    file: ./secret/zabbix-docker/.POSTGRES_USER
  POSTGRES_PASSWORD:
    #file: ./secret_example/.POSTGRES_PASSWORD # use for test
    file: ./secret/zabbix-docker/.POSTGRES_PASSWORD
